// StringSubstitute.cpp

#include "StdAfx.h"

#include "StringSubstitute.h"

void CStringSubstituter::Init(const CSubstituteInitPair *substituteInitPairs, int numPairs)
{
  for (int i = 0; i < numPairs; i++)
  {
    const CSubstituteInitPair &initPair = substituteInitPairs[i];
    CSubstitutePair pair;
    for (int j = 0; j < 2; j++)
      pair.Strings[j] = initPair.Strings[j];
    m_List.Add(pair);
  }
}

UString CStringSubstituter::Substitute(const UString &s, bool substitutionDirection)
{
  int fromIndex = (substitutionDirection ? 0 : 1);
  int toIndex = 1 - fromIndex;
  UString resultString;
  for (int i = 0; i < s.Length();)
  {
    int j;
    for (j = 0; j < m_List.Size(); j++)
    {
      const CSubstitutePair &pair = m_List[j];
      const UString &fromString = pair.Strings[fromIndex];
      int length = fromString.Length();
      if (s.Mid(i, length) == fromString)
      {
        resultString += pair.Strings[toIndex];
        i += length;
        break;
      }
    }
    if (j == m_List.Size())
    {
      resultString += s[i];
      i++;
    }
  }
  return resultString;
}
