// Windows/Resource/UpdateManager.cpp

#include "StdAfx.h"

#include "Windows/Defs.h"

#include "UpdateManager.h"

namespace NWindows {
namespace NResource {

CUpdateManager::~CUpdateManager()
{
  EndUpdate(true); // Discard
}

bool CUpdateManager::BeginUpdate(LPCTSTR fileName, bool deleteExistingResources)
{
  HANDLE tmpHandle =
    ::BeginUpdateResource(fileName, BoolToBOOL(deleteExistingResources));
  if (tmpHandle == NULL)
    return false;
  EndUpdate(true); // Discard
  m_UpdateFile = tmpHandle;
  return true;
}

bool CUpdateManager::Update(LPCTSTR type, LPCTSTR name, UINT16 language, LPVOID data, DWORD dataSize)
{
  if (m_UpdateFile == NULL)
    return false;
  return (::UpdateResource(m_UpdateFile, type, name, language, data, dataSize) != 0);
}

bool CUpdateManager::Delete(LPCTSTR type, LPCTSTR name, UINT16 language)
{
  return Update(type, name, language, NULL, 0);
}

bool CUpdateManager::EndUpdate(bool discard)
{
  if (m_UpdateFile == NULL)
    return false;
  if (::EndUpdateResource(m_UpdateFile, BoolToBOOL(discard)) == FALSE)
    return false;
  m_UpdateFile = NULL;
  return true;
}

}}
